hdu 5706 GirlCat【暴力DFS】

来源:互联网 发布:如何用微博做淘宝客 编辑:程序博客网 时间:2024/05/21 08:37

GirlCat

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 50    Accepted Submission(s): 42

Problem Description
As a cute girl, Kotori likes playing ``Hide and Seek'' with cats particularly.
Under the influence of Kotori, many girls and cats are playing ``Hide and Seek'' together.
Koroti shots a photo. The size of this photo is n×m, each pixel of the photo is a character of the lowercase(from `a' to `z').
Kotori wants to know how many girls and how many cats are there in the photo.
We define a girl as -- we choose a point as the start, passing by 4 different connected points continuously, and the four characters are exactly ``girl'' in the order.
We define two girls are different if there is at least a point of the two girls are different.
We define a cat as -- we choose a point as the start, passing by 3 different connected points continuously, and the three characters are exactly ``cat'' in the order.
We define two cats are different if there is at least a point of the two cats are different.
Two points are regarded to be connected if and only if they share a common edge.
Input
The first line is an integer T which represents the case number.
As for each case, the first line are two integers n and m, which are the height and the width of the photo.
Then there are n lines followed, and there are m characters of each line, which are the the details of the photo.
It is guaranteed that:
T is about 50.
1n1000.
1m1000.
(n×m)2×106.
Output
As for each case, you need to output a single line.
There should be 2 integers in the line with a blank between them representing the number of girls and cats respectively.
Please make sure that there is no extra blank
Sample Input
3
1 4
girl
2 3
oto
cat
3 4
girl
hrlt
hlca
Sample Output
1 0
0 2
4 1

题目大意:有n*m个格子,从某一个格子出发,能向周围四个方向走,如果能够走到的地方能够组成单词girl,或者是cat都进行计数,最终输出其个数。


思路:枚举每个点,如果是g,深搜来找单词girl,如果是c,深搜来找单词cat,因为能够走到的地方要是上一个格子的字母的下一个字母,所以这里极大的限制了Dfs走的层数,也极大的限制了能够走到的地方的个数,所以是不会超时的,我刚看到这个题的时候 ,感觉好蛋疼,数量级很大啊,1000*1000的图还要递归找单词,其实不然,不会超时滴。


AC代码:

#include<stdio.h>#include<string.h>using namespace std;char a[1005][1005];int fx[4]={0,0,-1,1};int fy[4]={1,-1,0,0};int ans;int n,m;void Dfs(int x,int y){    for(int i=0;i<4;i++)    {        int xx=x+fx[i];        int yy=y+fy[i];        if(xx>=0&&xx<n&&yy>=0&&yy<m)        {            if(a[x][y]=='g'&&a[xx][yy]=='i'||a[x][y]=='i'&&a[xx][yy]=='r')            {                Dfs(xx,yy);            }            if(a[x][y]=='r'&&a[xx][yy]=='l')ans++;        }    }}void Dfs2(int x,int y){    for(int i=0;i<4;i++)    {        int xx=x+fx[i];        int yy=y+fy[i];        if(xx>=0&&x<n&&yy>=0&&yy<m)        {            if(a[x][y]=='c'&&a[xx][yy]=='a')            {                Dfs2(xx,yy);            }            if(a[x][y]=='a'&&a[xx][yy]=='t')            {                ans++;            }        }    }}int main(){    int t;    scanf("%d",&t);    while(t--)    {        scanf("%d%d",&n,&m);        for(int i=0;i<n;i++)        {            scanf("%s",a[i]);        }        int output=0;        int output2=0;        for(int i=0;i<n;i++)        {            for(int j=0;j<m;j++)            {                if(a[i][j]=='g')                {                    ans=0;                    Dfs(i,j);                    output+=ans;                }                if(a[i][j]=='c')                {                    ans=0;                    Dfs2(i,j);                    output2+=ans;                }            }        }        printf("%d %d\n",output,output2);    }}







0 0
原创粉丝点击